
; === Serout2LCD-CustCharDemo.bas ==== 2009.06.20 ==== Ron Hackett ===

; This program runs on a PICAXE-28X1 processor. It sends 9-byte
; packets of serial data to the 14M-based serialized LCD display.

; In order for the LCD to function correctly, the master processor
; must send  data in "packets" of nine characters. The first char
; must be a command. The remaining 8 chars can be text or any command
; that moves the curser to a new location (i.e., 128-143 or 192-207)

; After each 9-byte packet is sent to the LCD, a brief delay is
; necessary to allow the LCD board enough time to update its display.

; ====================================================================


;=== Constants ===
					
	symbol abit =  100				;used to add pause between packets
	
;	HD44780 LCD Commands
	symbol D0 =   8					; display off
	symbol D1 =  12					; display on (cursor off)
	symbol DC =   1					; display clear (cursor home)
	symbol C0 =  12					; cursor off (display on)
	symbol C1 =  14					; cursor on  (no blink)
	symbol CB =  15					; cursor blink	
	symbol CH =   2					; cursor home (display not cleared)
	symbol LC =  16					; cursor left  one position
	symbol RC =  20					; cursor right one position
	symbol LS =  24					; scroll text left  one position
	symbol RS =  28					; scroll text right one position
	symbol Q1 = 128					; cursor at position 1 of line 1
	symbol Q2 = 136					; cursor at position 9 of line 1	
	symbol Q3 = 192					; cursor at position 1 of line 2
	symbol Q4 = 200					; cursor at position 9 of line 2
	
	
;=== Variables ===

	symbol pigs = b0
	symbol jigs = b1
	

;=== Directives ===

	'#com1								; set COM port for downloading
	#picaxe 28X1						; set compiler mode
	#no_data								; don't load data


;=== Begin Main Program ==============================================

	wait 1 ; allow time for LCD to initialize
	
;=== Initialize the data to be displayed ===
	
	serout 0,N4800_4,(Q1,"The   qu")
	pause abit
				
	serout 0,N4800_4,(Q2,"iet pigs")
	pause abit
	
	serout 0,N4800_4,(Q3,"only did")
	pause abit
	
	serout 0,N4800_4,(Q4,"   jigs.")
	pause abit
	
	
;=== Main Program Loop ===
	
do
	wait 2
	pigs = 3
	jigs = 2	
	gosub Update
	
	wait 2
	pigs = 5
	jigs = 4	
	gosub Update
	
	wait 2
	pigs = 8
	jigs = 6	
	gosub Update
	
loop

;=== End Main Program - Update Subroutine Follows ====================



;=== Update Subroutine ===

Update:
	
	serout 0,N4800_4,(Q1,132,#pigs,201,#jigs,Q1,Q1,Q1,Q1)
	pause abit

	return

